<%
'*********************************************************************************
' COMobjects.NET Deep Tree Script(c) Fedor Skvortsov, COMobjects.NET. November, 2001
' Mailto: fed@comobjects.net
' WWW: http://comobjects.net
'*********************************************************************************

Option Explicit
Response.ContentType = "text/xml"
'Change this variable to specify root folder
'Should be empty or ended to slash
Dim strRootPath
strRootPath = "/"
'Get relative path
Dim strPath
strPath = Request.QueryString("path")
'Prevent using path ../../ which allows somebody to go higher that root folder
If InStr(1, Server.MapPath(strRootPath & strPath), Server.MapPath(strRootPath), 1) <> 1 Then
	Err.Raise 7101, "COMobjectsNET.DeepTree", "Security Error"
	Response.End
End If
'Creating xml document
Dim xmlDoc
Set xmlDoc = Server.CreateObject("Msxml2.DOMDocument.3.0")
Dim xmlPI, xmlElement, xmlAtt
'Set encoding of XML document
Set xmlPI = xmlDoc.appendChild(xmlDoc.createProcessingInstruction("xml", "version='1.0' encoding='Windows-1252'"))
'Create root element and set base attribute
Set xmlDoc.documentElement = xmlDoc.createElement("Tree")
Set xmlAtt = xmlDoc.documentElement.Attributes.setNamedItem(xmlDoc.createAttribute("base"))
xmlAtt.Value = strRootPath & strPath
'Reading subfolder and files
Dim objFileSystemObject, objDirectory, objSubDirectory, objFile
Set objFileSystemObject = Server.CreateObject("Scripting.FileSystemObject")
Set objDirectory = objFileSystemObject.GetFolder(Server.MapPath(strRootPath & strPath))
For Each objSubDirectory In objDirectory.SubFolders
	'Create tree node
	Set xmlElement = xmlDoc.documentElement.appendChild(xmlDoc.createElement("TreeNode"))
	'Set attribute "icon" to value "folder"
	Set xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("icon"))
	xmlAtt.value = "folder"
	'Make attribute "name" equal to folder name	
	Set xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("name"))
	xmlAtt.value = objSubDirectory.Name
	 'Using attribute "src" for linking it to subtree	
	Set xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("src"))
	xmlAtt.value = "Files.asp?path=" & Server.URLEncode(strPath & objSubDirectory.Name & "/")
Next
For Each objFile In objDirectory.Files
	'Create tree node
	Set xmlElement = xmlDoc.documentElement.appendChild(xmlDoc.createElement("TreeNode"))
	'Set attribute "icon" to value "item"    
	Set xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("icon"))
	xmlAtt.value = "item"
	'Make attribute "name" equal to file name
	Set xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("name"))
	xmlAtt.value = objFile.Name	
	'Set attribute "target"	
	Set xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("target"))
	xmlAtt.value = "main"
	 'Combine attributes "href" and "base" of root element to get link to the file		
	Set xmlAtt = xmlElement.Attributes.setNamedItem(xmlDoc.createAttribute("href"))
	xmlAtt.value = objFile.Name
Next
'Write directly to response stream
xmlDoc.save Response
%>
